import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeReservedInstancesOfferingsRequest, DescribeReservedInstancesOfferingsResult, } from "../models/models_4";
import { deserializeAws_ec2DescribeReservedInstancesOfferingsCommand, serializeAws_ec2DescribeReservedInstancesOfferingsCommand, } from "../protocols/Aws_ec2";
var DescribeReservedInstancesOfferingsCommand = (function (_super) {
    __extends(DescribeReservedInstancesOfferingsCommand, _super);
    function DescribeReservedInstancesOfferingsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeReservedInstancesOfferingsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "DescribeReservedInstancesOfferingsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeReservedInstancesOfferingsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeReservedInstancesOfferingsResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeReservedInstancesOfferingsCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2DescribeReservedInstancesOfferingsCommand(input, context);
    };
    DescribeReservedInstancesOfferingsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2DescribeReservedInstancesOfferingsCommand(output, context);
    };
    return DescribeReservedInstancesOfferingsCommand;
}($Command));
export { DescribeReservedInstancesOfferingsCommand };
