import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { EC2ClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../EC2Client";
import { DeprovisionIpamPoolCidrRequest, DeprovisionIpamPoolCidrResult } from "../models/models_2";
export interface DeprovisionIpamPoolCidrCommandInput extends DeprovisionIpamPoolCidrRequest {
}
export interface DeprovisionIpamPoolCidrCommandOutput extends DeprovisionIpamPoolCidrResult, __MetadataBearer {
}

export declare class DeprovisionIpamPoolCidrCommand extends $Command<DeprovisionIpamPoolCidrCommandInput, DeprovisionIpamPoolCidrCommandOutput, EC2ClientResolvedConfig> {
    readonly input: DeprovisionIpamPoolCidrCommandInput;
    constructor(input: DeprovisionIpamPoolCidrCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: EC2ClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeprovisionIpamPoolCidrCommandInput, DeprovisionIpamPoolCidrCommandOutput>;
    private serialize;
    private deserialize;
}
